Bug Hunting Session
Bug 93814 - cache binary compiled versions of shaders ...
Summary: cache binary compiled versions of shaders ...
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: graphics stack (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: Other All
: medium normal
Assignee: Not Assigned
URL:
Whiteboard: target:5.1.0 target:5.0.2
Keywords:
Depends on:
Blocks: VCL-OpenGL
  Show dependency treegraph
 
Reported: 2015-08-31 16:38 UTC by Michael Meeks
Modified: 2016-10-25 19:21 UTC (History)
1 user (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Michael Meeks 2015-08-31 16:38:01 UTC
We should use:

http://www.geeks3d.com/20100727/opengl-4-1-allows-the-use-of-binary-shaders/

glGetProgramBinary and glProgramBinary and its friends to serialize pre-compiled shaders - to avoid having to pay the cost of re-compiling them on startup each time.

We should presumably re-use the cache directory (and/or code) that we do the same thing for openCL for in this regard; I forget if we use a hash of the program string to do that or ... anyhow =) shouldn't be too difficult I hope.
Comment 1 Michael Meeks 2015-08-31 16:38:40 UTC
Of course, this is just an optimization - if glew doesn't find the symbols, that's fine too.
Comment 2 Commit Notification 2015-09-15 15:08:40 UTC
Marco Cecchetti committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=d8f78d624b779244f5953fd32960c4f487e320d3

tdf#93814: Added support for caching shader program binaries.

It will be available in 5.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 3 Commit Notification 2015-09-16 13:22:20 UTC
Marco Cecchetti committed a patch related to this issue.
It has been pushed to "libreoffice-5-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=697917f7152b4ab5d95eadeac52d615403ea1737&h=libreoffice-5-0

tdf#93814: Added support for caching shader program binaries.

It will be available in 5.0.3.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 4 Commit Notification 2015-09-16 17:50:03 UTC
Marco Cecchetti committed a patch related to this issue.
It has been pushed to "libreoffice-5-0-2":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=9861e8c174bb950a3b7d2af1f17dcfcb430e4055&h=libreoffice-5-0-2

tdf#93814: Added support for caching shader program binaries.

It will be available in 5.0.2.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.